diff --git a/src/interfaces/ecpg/ecpglib/misc.c b/src/interfaces/ecpg/ecpglib/misc.c
index 2ae989e3e5..110f73d3dd 100644
--- a/src/interfaces/ecpg/ecpglib/misc.c
+++ b/src/interfaces/ecpg/ecpglib/misc.c
@@ -274,8 +274,8 @@ ecpg_log(const char *format,...)
 		/* dump out internal sqlca variables */
 		if (ecpg_internal_regression_mode && sqlca != NULL)
 		{
-			fprintf(debugstream, "[NO_PID]: sqlca: code: %ld, state: %s\n",
-					sqlca->sqlcode, sqlca->sqlstate);
+			fprintf(debugstream, "[NO_PID]: sqlca: code: %ld, state: %.*s\n",
+					sqlca->sqlcode, (int) sizeof(sqlca->sqlstate), sqlca->sqlstate);
 		}
 
 		fflush(debugstream);
